import Octokit from '@octokit/rest';
interface CheckOptions {
    /** The annotations to be posted to the GitHub check */
    annotations: Octokit.ChecksCreateParamsOutputAnnotations[];
    /** The number or errors generated during the run */
    errorCount: number;
    /** The number or warnings generated during the run */
    warningCount?: number;
    /** The GitHub app id to create the check with */
    appId: number;
    /** The GitHub private key to create the check with */
    privateKey: string;
    /** The name of the tool thats running */
    tool: string;
    /** The title of the check mark */
    name: string;
}
/** Add a GitHub check with annotations to the HEAD sha */
export default function createCheck({ annotations, errorCount, warningCount, appId, privateKey, tool, name }: CheckOptions): Promise<void>;
export {};
//# sourceMappingURL=index.d.ts.map